> ## Documentation Index
> Fetch the complete documentation index at: https://developers.hubspot.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update draft

> Update the draft configuration for a specific lead score in your HubSpot account. This endpoint allows you to replace the current draft of a lead score configuration identified by the scoreId. Use this endpoint to make changes to the scoring criteria before publishing the final version. Rule and group IDs may differ between the live and draft configurations. Outputs are merged by ID and will remain the same. 

> [accordion] Supported products

> [accordion] Required Scopes


## OpenAPI

````yaml specs/2027-03-beta/marketing-lead-scoring-v2027-03-beta.json PUT /marketing/lead-scoring/2027-03-beta/scores/{scoreId}/draft
openapi: 3.0.1
info:
  title: Marketing Lead Scoring
  description: Basepom for all HubSpot Projects
  version: 2027-03-beta
  x-hubspot-product-tier-requirements:
    marketing: FREE
    sales: FREE
    service: FREE
    cms: FREE
    commerce: FREE
    crmHub: FREE
    dataHub: FREE
servers:
  - url: https://api.hubapi.com
security: []
tags:
  - name: Advanced
  - name: Basic
paths:
  /marketing/lead-scoring/2027-03-beta/scores/{scoreId}/draft:
    put:
      tags:
        - Advanced
      summary: Update draft score
      description: >-
        Update the draft configuration for a specific lead score in your HubSpot
        account. This endpoint allows you to replace the current draft of a lead
        score configuration identified by the scoreId. Use this endpoint to make
        changes to the scoring criteria before publishing the final version.
        Rule and group IDs may differ between the live and draft configurations.
        Outputs are merged by ID and will remain the same. 
      operationId: put-/marketing/lead-scoring/2027-03-beta/scores/{scoreId}/draft
      parameters:
        - name: scoreId
          in: path
          description: The unique identifier of the lead score draft to update.
          required: true
          style: simple
          explode: false
          schema:
            type: integer
            format: int64
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PublicDraftUpdateRequest'
        required: true
      responses:
        '200':
          description: successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PublicScoreConfiguration'
        default:
          $ref: '#/components/responses/Error'
          description: ''
      security: []
components:
  schemas:
    PublicDraftUpdateRequest:
      required:
        - allowedGroupTypes
        - groupConfigs
        - name
        - objectTypeId
      type: object
      properties:
        allowedGroupTypes:
          type: array
          description: >-
            An array of strings indicating the types of groups allowed in the
            scoring draft. Valid values include 'FIT' and 'INTENT'.
          items:
            type: string
            enum:
              - FIT
              - INTENT
        filterConfiguration:
          $ref: '#/components/schemas/PublicFilterConfiguration'
        groupConfigs:
          type: array
          description: >-
            An array of PublicScoreGroupConfiguration objects that define the
            group configurations for the scoring draft.
          items:
            $ref: '#/components/schemas/PublicScoreGroupConfiguration'
        maxScorePerCategory:
          type: integer
          description: >-
            An integer representing the maximum score allowed per category in
            the scoring draft.
          format: int32
        name:
          type: string
          description: A string representing the name of the draft configuration.
        objectTypeId:
          type: string
          description: >-
            A string representing the unique identifier of the object type
            associated with the draft.
        outputConfiguration:
          $ref: '#/components/schemas/PublicOutputConfigurationEgg'
    PublicScoreConfiguration:
      required:
        - allowedGroupTypes
        - groupConfigs
        - id
        - name
        - objectTypeId
        - scoreStatus
        - scoreType
      type: object
      properties:
        allowedGroupTypes:
          type: array
          description: >-
            An array of allowed group types for the scoring configuration, with
            valid values being 'FIT' and 'INTENT'.
          items:
            type: string
            enum:
              - FIT
              - INTENT
        createdAt:
          type: string
          description: >-
            The date and time when this scoring configuration was created, in
            ISO 8601 format.
          format: date-time
        filterConfiguration:
          $ref: '#/components/schemas/PublicFilterConfiguration'
        groupConfigs:
          type: array
          description: >-
            An array of configurations for scoring groups, each defined by a
            PublicScoreGroupConfiguration object.
          items:
            $ref: '#/components/schemas/PublicScoreGroupConfiguration'
        id:
          type: string
          description: The unique identifier for this scoring configuration.
        lastConfigurationChangeTimestamp:
          type: string
          format: date-time
        maxScore:
          type: integer
          description: >-
            The maximum score that can be assigned overall, represented as an
            integer.
          format: int32
        maxScorePerCategory:
          type: integer
          description: >-
            The maximum score that can be assigned per category, represented as
            an integer.
          format: int32
        name:
          type: string
          description: The name of the scoring configuration.
        objectTypeId:
          type: string
          description: >-
            The identifier for the type of object that this score configuration
            is associated with.
        outputConfiguration:
          $ref: '#/components/schemas/PublicOutputConfiguration'
        publishedAt:
          type: string
          description: >-
            The date and time when this scoring configuration was published, in
            ISO 8601 format.
          format: date-time
        scoreStatus:
          type: string
          description: The current status of the score, represented as a string.
        scoreType:
          type: string
          description: The type of scoring applied, represented as a string.
        updatedAt:
          type: string
          description: >-
            The date and time when this scoring configuration was last updated,
            in ISO 8601 format.
          format: date-time
    PublicFilterConfiguration:
      required:
        - listFilterType
        - segmentIds
      type: object
      properties:
        listFilterType:
          type: string
          description: >-
            A string indicating the type of filter to apply. Valid values are
            'INCLUDES' and 'EXCLUDES'.
          enum:
            - EXCLUDES
            - INCLUDES
        segmentIds:
          type: array
          description: >-
            An array of integers representing the IDs of the segments to be
            filtered.
          items:
            type: integer
            format: int32
    PublicScoreGroupConfiguration:
      required:
        - groupCategory
        - groupName
        - id
        - ruleConfigurations
      type: object
      properties:
        groupCategory:
          type: string
          description: >-
            The category of the scoring group, which can be either 'FIT' or
            'INTENT'.
          enum:
            - FIT
            - INTENT
        groupDecay:
          $ref: '#/components/schemas/PublicGroupDecayConfiguration'
        groupName:
          type: string
          description: The name assigned to the scoring group.
        id:
          type: string
          description: The unique identifier for the scoring group configuration.
        maxValue:
          type: number
          description: The maximum score value that can be assigned within this group.
        minValue:
          type: number
          description: The minimum score value that can be assigned within this group.
        ruleConfigurations:
          type: array
          description: >-
            An array of rule configurations that define the scoring rules
            applied within this group.
          items:
            $ref: '#/components/schemas/PublicScoreRuleConfiguration'
    PublicOutputConfigurationEgg:
      required:
        - outputs
      type: object
      properties:
        outputs:
          type: array
          description: >-
            An array of output configurations, each of which can be a score,
            threshold, or matrix output override. This property is required.
          items:
            oneOf:
              - $ref: '#/components/schemas/PublicScoreOutputOverride'
              - $ref: '#/components/schemas/PublicThresholdOutputOverride'
              - $ref: '#/components/schemas/PublicMatrixOutputOverride'
    PublicOutputConfiguration:
      required:
        - outputs
      type: object
      properties:
        outputs:
          type: array
          description: >-
            An array of output properties, each of which can be a score,
            threshold, or matrix output property. These define how the scoring
            results are structured and presented.
          items:
            oneOf:
              - $ref: '#/components/schemas/PublicScoreOutputProperty'
              - $ref: '#/components/schemas/PublicThresholdOutputProperty'
              - $ref: '#/components/schemas/PublicMatrixOutputProperty'
    Error:
      required:
        - category
        - correlationId
        - message
      type: object
      properties:
        category:
          type: string
          description: The error category.
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: Context about the error condition.
          example: >-
            {invalidPropertyName=[propertyValue], missingScopes=[scope1,
            scope2]}
        correlationId:
          type: string
          description: >-
            A unique identifier for the request. Include this value with any
            error reports or support tickets.
          format: uuid
          example: aeb5f871-7f07-4993-9211-075dc63e7cbf
        errors:
          type: array
          description: Further information about the error.
          items:
            $ref: '#/components/schemas/ErrorDetail'
        links:
          type: object
          additionalProperties:
            type: string
          description: >-
            A map of link names to associated URIs containing documentation
            about the error or recommended remediation steps.
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate.
          example: An error occurred
        subCategory:
          type: string
          description: >-
            A specific category that contains more specific detail about the
            error.
      description: >-
        Represents an error response returned by the API when an operation
        fails. This component is used in various endpoints to provide detailed
        information about the error encountered.
      example:
        message: Invalid input (details will vary based on the error)
        correlationId: aeb5f871-7f07-4993-9211-075dc63e7cbf
        category: VALIDATION_ERROR
        links:
          knowledge-base: https://www.hubspot.com/products/service/knowledge-base
    PublicGroupDecayConfiguration:
      required:
        - decayIntervalDays
        - percentToDecayPerInterval
      type: object
      properties:
        decayIntervalDays:
          type: integer
          description: >-
            The number of days that constitute one decay interval. This is an
            integer value.
          format: int32
        percentToDecayPerInterval:
          type: integer
          description: >-
            The percentage by which the score will decay at the end of each
            interval. This is an integer value.
          format: int32
    PublicScoreRuleConfiguration:
      required:
        - configuration
        - enabled
        - id
      type: object
      properties:
        configuration:
          $ref: '#/components/schemas/PublicRuleConfiguration'
        enabled:
          type: boolean
          description: A boolean indicating whether the scoring rule is active.
        id:
          type: string
          description: A string that uniquely identifies the scoring rule configuration.
        maxValue:
          type: number
          description: A number representing the maximum value for the scoring rule.
        minValue:
          type: number
          description: A number representing the minimum value for the scoring rule.
    PublicScoreOutputOverride:
      title: SCORE
      required:
        - id
        - outputType
      type: object
      properties:
        id:
          type: string
          description: The unique identifier for this score output override.
        internalPropertyName:
          type: string
          description: The internal name used to reference this property within the system.
        outputType:
          type: string
          description: >-
            The type of output for this score override. It defaults to 'SCORE'
            and must be 'SCORE'.
          default: SCORE
          enum:
            - SCORE
        propertyDescription:
          type: string
          description: >-
            A description of the property, providing additional context or
            details.
        propertyGroup:
          type: string
          description: >-
            The group to which this property belongs, used for organizational
            purposes.
        propertyLabel:
          type: string
          description: The label displayed for this property, intended for user interfaces.
      x-hubspot-sub-type-impl: true
    PublicThresholdOutputOverride:
      title: THRESHOLD
      required:
        - boundaries
        - id
        - outputType
      type: object
      properties:
        boundaries:
          type: array
          description: >-
            An array of objects defining the boundaries for the threshold tiers,
            each represented by a PublicThresholdTierBoundary.
          items:
            $ref: '#/components/schemas/PublicThresholdTierBoundary'
        id:
          type: string
          description: >-
            A string that serves as the unique identifier for this threshold
            output override.
        internalPropertyName:
          type: string
          description: >-
            A string representing the internal name of the property associated
            with this threshold.
        outputType:
          type: string
          description: >-
            A string representing the type of output, which is 'THRESHOLD' for
            this component.
          default: THRESHOLD
          enum:
            - THRESHOLD
        propertyDescription:
          type: string
          description: A string that describes the purpose or details of the property.
        propertyGroup:
          type: string
          description: A string indicating the group to which this property belongs.
        propertyLabel:
          type: string
          description: A string that provides a human-readable label for the property.
      x-hubspot-sub-type-impl: true
    PublicMatrixOutputOverride:
      title: MATRIX
      required:
        - boundaries
        - id
        - outputType
      type: object
      properties:
        boundaries:
          type: object
          additionalProperties:
            type: array
            items:
              $ref: '#/components/schemas/PublicMatrixTierBoundary'
          description: >-
            An object defining the boundaries for the matrix output, where each
            key is a boundary name and the value is an array of
            PublicMatrixTierBoundary objects.
        id:
          type: string
          description: The unique identifier for this matrix output override.
        internalPropertyName:
          type: string
          description: >-
            The internal name of the property associated with this matrix
            output.
        outputType:
          type: string
          description: The type of output, which is always 'MATRIX'.
          default: MATRIX
          enum:
            - MATRIX
        propertyDescription:
          type: string
          description: >-
            A description of the property, providing additional context or
            details.
        propertyGroup:
          type: string
          description: The group to which this property belongs.
        propertyLabel:
          type: string
          description: The label of the property for display purposes.
      x-hubspot-sub-type-impl: true
    PublicScoreOutputProperty:
      title: SCORE
      required:
        - categories
        - id
        - outputType
        - propertyLabel
        - propertyName
      type: object
      properties:
        categories:
          type: array
          description: >-
            An array of categories associated with this property, which can
            include 'FIT' and 'INTENT'.
          items:
            type: string
            enum:
              - FIT
              - INTENT
        id:
          type: string
          description: The unique identifier for this scoring output property.
        outputType:
          type: string
          description: The type of output for this property, which is always 'SCORE'.
          default: SCORE
          enum:
            - SCORE
        propertyDescription:
          type: string
          description: >-
            A description of the property, providing additional context or
            details.
        propertyGroup:
          type: string
          description: >-
            The group to which this property belongs, used for organizational
            purposes.
        propertyLabel:
          type: string
          description: The label of the property as it appears in the user interface.
        propertyName:
          type: string
          description: The internal name of the property used for the scoring output.
      x-hubspot-sub-type-impl: true
    PublicThresholdOutputProperty:
      title: THRESHOLD
      required:
        - boundaries
        - categories
        - id
        - outputType
        - propertyLabel
        - propertyName
      type: object
      properties:
        boundaries:
          type: array
          description: >-
            An array of threshold tier boundaries that define the limits and
            labels for categorizing scores.
          items:
            $ref: '#/components/schemas/PublicThresholdTierBoundary'
        categories:
          type: array
          description: >-
            An array of categories associated with the property, valid values
            include 'FIT' and 'INTENT'.
          items:
            type: string
            enum:
              - FIT
              - INTENT
        id:
          type: string
          description: The unique identifier for this threshold output property.
        outputType:
          type: string
          description: The type of output, which is 'THRESHOLD' for this component.
          default: THRESHOLD
          enum:
            - THRESHOLD
        propertyDescription:
          type: string
          description: A description of the property.
        propertyGroup:
          type: string
          description: The group to which this property belongs.
        propertyLabel:
          type: string
          description: The display label for the property.
        propertyName:
          type: string
          description: The internal name of the property.
      x-hubspot-sub-type-impl: true
    PublicMatrixOutputProperty:
      title: MATRIX
      required:
        - boundaries
        - categories
        - id
        - outputType
        - propertyLabel
        - propertyName
      type: object
      properties:
        boundaries:
          type: object
          additionalProperties:
            type: array
            items:
              $ref: '#/components/schemas/PublicMatrixTierBoundary'
          description: >-
            An object defining the boundaries for the matrix tiers, with each
            boundary represented as an array of PublicMatrixTierBoundary
            objects.
        categories:
          type: array
          description: >-
            An array of categories applicable to this property, with valid
            values being 'FIT' and 'INTENT'.
          items:
            type: string
            enum:
              - FIT
              - INTENT
        id:
          type: string
          description: The unique identifier for the matrix output property.
        outputType:
          type: string
          description: The type of output, which is always 'MATRIX' for this component.
          default: MATRIX
          enum:
            - MATRIX
        propertyDescription:
          type: string
          description: A description of the property's purpose or usage.
        propertyGroup:
          type: string
          description: The group to which this property belongs, if applicable.
        propertyLabel:
          type: string
          description: The label displayed for the property in user interfaces.
        propertyName:
          type: string
          description: >-
            The internal name of the property associated with this matrix
            output.
      x-hubspot-sub-type-impl: true
    ErrorDetail:
      required:
        - message
      type: object
      properties:
        code:
          type: string
          description: >-
            The status code associated with the error detail. This is a string
            property.
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: >-
            Context about the error condition, represented as an object where
            each key is a context name and the value is an array of strings
            providing further details.
          example: '{missingScopes=[scope1, scope2]}'
        in:
          type: string
          description: >-
            The name of the field or parameter in which the error was found.
            This is a string property.
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate. It is a required string property.
        subCategory:
          type: string
          description: >-
            A specific category that contains more specific detail about the
            error. This is a string property.
      description: >-
        Represents detailed information about an error that occurred in the API.
        This component is used to provide additional context and specifics about
        errors, typically as part of an error response.
    PublicRuleConfiguration:
      required:
        - calculation
      type: object
      properties:
        calculation:
          description: >-
            Defines the method of calculation for the scoring rule. It can be
            one of several types, such as a constant value, match calculator,
            multi-value calculator, conditional calculator, multi-unified event
            rollup calculator, association object rollup calculator, association
            unified event rollup calculator, or segment membership calculator.
          oneOf:
            - $ref: '#/components/schemas/PublicConstantValueCalculator'
            - $ref: '#/components/schemas/PublicMatchCalculator'
            - $ref: '#/components/schemas/PublicMultiValueCalculator'
            - $ref: '#/components/schemas/PublicConditionalCalculator'
            - $ref: '#/components/schemas/PublicMultiUnifiedEventRollupCalculator'
            - $ref: '#/components/schemas/PublicAssociationObjectRollupCalculator'
            - $ref: >-
                #/components/schemas/PublicAssociationUnifiedEventRollupCalculator
            - $ref: '#/components/schemas/PublicSegmentMembershipCalculator'
    PublicThresholdTierBoundary:
      required:
        - label
        - threshold
      type: object
      properties:
        color:
          type: string
          description: >-
            A string representing the color associated with the threshold tier
            boundary. Valid values include 'GREEN', 'RED', 'YELLOW', 'BLUE',
            'ORANGE', 'PURPLE', 'MAGENTA', and 'GRAY'.
          enum:
            - BLUE
            - GRAY
            - GREEN
            - MAGENTA
            - ORANGE
            - PURPLE
            - RED
            - YELLOW
        label:
          type: string
          description: A string representing the label for the threshold tier boundary.
        newLabel:
          type: string
          description: >-
            A string representing a new label for the threshold tier boundary,
            if applicable.
        threshold:
          type: number
          description: A number indicating the threshold value for the tier boundary.
    PublicMatrixTierBoundary:
      required:
        - label
        - threshold
      type: object
      properties:
        label:
          type: string
          description: >-
            A string representing the name or identifier for the matrix tier
            boundary.
        threshold:
          type: number
          description: >-
            A number indicating the threshold value for the matrix tier
            boundary.
    PublicConstantValueCalculator:
      title: CONSTANT
      required:
        - type
        - value
      type: object
      properties:
        type:
          type: string
          description: >-
            A string that specifies the type of calculator, which is always
            'CONSTANT' for this component.
          default: CONSTANT
          enum:
            - CONSTANT
        value:
          type: number
          description: A numerical value that represents the constant score to be applied.
      x-hubspot-sub-type-impl: true
    PublicMatchCalculator:
      title: MATCH
      required:
        - matchRules
        - property
        - type
      type: object
      properties:
        defaultValue:
          type: number
          description: >-
            A number representing the default value to be used if no match rules
            are satisfied.
        matchRules:
          type: array
          description: >-
            An array of match rules that define the conditions under which the
            property is evaluated. Each rule specifies an operation and a value.
          items:
            $ref: '#/components/schemas/PublicMatchRule'
        property:
          type: string
          description: >-
            The name of the property that is being evaluated by the match
            calculator.
        type:
          type: string
          description: >-
            A string that indicates the type of calculator, which is always
            'MATCH'.
          default: MATCH
          enum:
            - MATCH
      x-hubspot-sub-type-impl: true
    PublicMultiValueCalculator:
      title: MULTI
      required:
        - calculators
        - type
      type: object
      properties:
        calculators:
          type: array
          description: >-
            An array of calculators that are combined to perform the multi-value
            calculation. Each item in the array can be a constant value
            calculator, match calculator, multi-value calculator, conditional
            calculator, or segment membership calculator.
          items:
            oneOf:
              - $ref: '#/components/schemas/PublicConstantValueCalculator'
              - $ref: '#/components/schemas/PublicMatchCalculator'
              - $ref: '#/components/schemas/PublicMultiValueCalculator'
              - $ref: '#/components/schemas/PublicConditionalCalculator'
              - $ref: '#/components/schemas/PublicSegmentMembershipCalculator'
        type:
          type: string
          description: >-
            A string indicating the type of calculator, which is 'MULTI' for
            this component.
          default: MULTI
          enum:
            - MULTI
      x-hubspot-sub-type-impl: true
    PublicConditionalCalculator:
      title: CONDITIONAL
      required:
        - type
        - value
        - whereCondition
      type: object
      properties:
        type:
          type: string
          description: >-
            A string indicating the type of calculator, which is 'CONDITIONAL'
            for this component.
          default: CONDITIONAL
          enum:
            - CONDITIONAL
        value:
          type: number
          description: >-
            A number representing the value to be used if the conditions
            specified in whereCondition are met.
        whereCondition:
          $ref: '#/components/schemas/PublicCompositeCondition'
      x-hubspot-sub-type-impl: true
    PublicMultiUnifiedEventRollupCalculator:
      title: MULTI_UE
      required:
        - eventCalculators
        - type
      type: object
      properties:
        eventCalculators:
          type: array
          description: >-
            An array of event calculator entries, each defining a specific event
            calculation configuration.
          items:
            $ref: '#/components/schemas/PublicMultiUnifiedEventCalculatorEntry'
        type:
          type: string
          description: >-
            A string indicating the type of calculator. The default value is
            'MULTI_UE'.
          default: MULTI_UE
          enum:
            - MULTI_UE
      x-hubspot-sub-type-impl: true
    PublicAssociationObjectRollupCalculator:
      title: ASSOCIATIONS
      required:
        - associatedObjectTypeId
        - associationSpec
        - inverseAssociationSpec
        - recordCalculation
        - rollupType
        - type
      type: object
      properties:
        associatedObjectTypeId:
          type: string
          description: A string representing the type ID of the associated object.
        associationFilters:
          $ref: '#/components/schemas/PublicAssociationFilter'
        associationSpec:
          $ref: '#/components/schemas/PublicAssociationSpec'
        inverseAssociationSpec:
          $ref: '#/components/schemas/PublicAssociationSpec'
        recordCalculation:
          description: >-
            Specifies the calculation method to be used on the records, which
            can be one of several types such as constant value, match,
            multi-value, conditional, or segment membership calculators.
          oneOf:
            - $ref: '#/components/schemas/PublicConstantValueCalculator'
            - $ref: '#/components/schemas/PublicMatchCalculator'
            - $ref: '#/components/schemas/PublicMultiValueCalculator'
            - $ref: '#/components/schemas/PublicConditionalCalculator'
            - $ref: '#/components/schemas/PublicSegmentMembershipCalculator'
        rollupType:
          type: string
          description: >-
            A string indicating the type of rollup operation, with valid values
            being 'SUM', 'MAX', 'MIN', or 'AVG'.
          enum:
            - AVG
            - MAX
            - MIN
            - SUM
        type:
          type: string
          description: A string indicating the type of calculator, which is 'ASSOCIATIONS'.
          default: ASSOCIATIONS
          enum:
            - ASSOCIATIONS
      x-hubspot-sub-type-impl: true
    PublicAssociationUnifiedEventRollupCalculator:
      title: ASSOCIATION_UE
      required:
        - associatedObjectTypeId
        - associationSpec
        - inverseAssociationSpec
        - recordCalculation
        - rollupType
        - type
      type: object
      properties:
        associatedObjectTypeId:
          type: string
          description: >-
            A string representing the unique identifier of the associated object
            type.
        associationFilters:
          $ref: '#/components/schemas/PublicAssociationFilter'
        associationSpec:
          $ref: '#/components/schemas/PublicAssociationSpec'
        inverseAssociationSpec:
          $ref: '#/components/schemas/PublicAssociationSpec'
        recordCalculation:
          $ref: '#/components/schemas/PublicMultiUnifiedEventRollupCalculator'
        rollupType:
          type: string
          description: >-
            A string indicating the type of rollup operation to perform, with
            valid values being 'SUM', 'MAX', 'MIN', and 'AVG'.
          enum:
            - AVG
            - MAX
            - MIN
            - SUM
        type:
          type: string
          description: >-
            A string indicating the type of calculator, which is
            'ASSOCIATION_UE'.
          default: ASSOCIATION_UE
          enum:
            - ASSOCIATION_UE
      x-hubspot-sub-type-impl: true
    PublicSegmentMembershipCalculator:
      title: SEGMENT_MEMBERSHIP
      required:
        - segmentMembershipRules
        - type
      type: object
      properties:
        segmentMembershipRules:
          type: array
          description: >-
            An array of rules that define the criteria for segment membership.
            Each rule is represented by a PublicSegmentMembershipRule object.
          items:
            $ref: '#/components/schemas/PublicSegmentMembershipRule'
        type:
          type: string
          description: >-
            A string indicating the type of calculator, which is
            'SEGMENT_MEMBERSHIP' by default.
          default: SEGMENT_MEMBERSHIP
          enum:
            - SEGMENT_MEMBERSHIP
      x-hubspot-sub-type-impl: true
    PublicMatchRule:
      required:
        - operation
        - value
      type: object
      properties:
        operation:
          description: >-
            Defines the operation to be performed for the match rule. It can be
            one of several types, such as boolean, number, string, date-time,
            and more, each with specific operations applicable to that type.
          oneOf:
            - $ref: '#/components/schemas/PublicBoolPropertyOperation'
            - $ref: '#/components/schemas/PublicNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDateTimePropertyOperation'
            - $ref: '#/components/schemas/PublicRangedDatePropertyOperation'
            - $ref: '#/components/schemas/PublicComparativePropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicComparativeDatePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingDateRangePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingPropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicEnumerationPropertyOperation'
            - $ref: '#/components/schemas/PublicAllPropertyTypesOperation'
            - $ref: '#/components/schemas/PublicRangedNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicMultiStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDatePropertyOperation'
            - $ref: '#/components/schemas/PublicCalendarDatePropertyOperation'
            - $ref: '#/components/schemas/PublicTimePointOperation'
            - $ref: '#/components/schemas/PublicRangedTimeOperation'
            - $ref: '#/components/schemas/PublicComparativeStringPropertyOperation'
            - $ref: '#/components/schemas/PublicComparativeNumberPropertyOperation'
        value:
          type: number
          description: >-
            A number representing the value to be used in the match rule. This
            value is compared against the property using the specified
            operation.
    PublicCompositeCondition:
      title: COMPOSITE
      required:
        - conditions
        - operator
        - type
      type: object
      properties:
        conditions:
          type: array
          description: >-
            An array of conditions that can include both single and composite
            conditions, allowing for nested logical expressions.
          items:
            oneOf:
              - $ref: '#/components/schemas/PublicSingleCondition'
              - $ref: '#/components/schemas/PublicCompositeCondition'
        operator:
          type: string
          description: >-
            A string that defines the logical operator used to combine the
            conditions. The valid value is 'AND'.
          enum:
            - AND
        type:
          type: string
          description: >-
            A string that specifies the type of condition, which is 'COMPOSITE'
            for this component.
          default: COMPOSITE
          enum:
            - COMPOSITE
      x-hubspot-sub-type-impl: true
    PublicMultiUnifiedEventCalculatorEntry:
      required:
        - eventTypeId
        - recordCalculation
      type: object
      properties:
        eventFrequencyCriteria:
          description: >-
            Defines the criteria for event frequency, specifically using a
            'between' type to specify frequency ranges.
          oneOf:
            - $ref: '#/components/schemas/PublicEventFrequencyBetween'
        eventTimeframe:
          $ref: '#/components/schemas/PublicEventTimeframe'
        eventTypeId:
          type: string
          description: The unique identifier for the type of event. It is a string.
        recordCalculation:
          description: >-
            Defines the calculation logic for the event record. It can be one of
            several types, including constant value, match, multi-value,
            conditional, or segment membership calculators.
          oneOf:
            - $ref: '#/components/schemas/PublicConstantValueCalculator'
            - $ref: '#/components/schemas/PublicMatchCalculator'
            - $ref: '#/components/schemas/PublicMultiValueCalculator'
            - $ref: '#/components/schemas/PublicConditionalCalculator'
            - $ref: '#/components/schemas/PublicSegmentMembershipCalculator'
    PublicAssociationFilter:
      required:
        - propertyFilters
      type: object
      properties:
        propertyFilters:
          type: array
          description: >-
            An array of property filters that define the criteria for filtering
            associations. Each filter is represented by a PublicPropertyFilter
            object.
          items:
            $ref: '#/components/schemas/PublicPropertyFilter'
    PublicAssociationSpec:
      required:
        - associationCategory
        - associationTypeId
      type: object
      properties:
        associationCategory:
          type: string
          description: A string indicating the category of the association.
        associationTypeId:
          type: integer
          description: >-
            An integer representing the unique identifier for the type of
            association.
          format: int32
    PublicSegmentMembershipRule:
      required:
        - operation
        - segmentIds
        - value
      type: object
      properties:
        operation:
          type: string
          description: >-
            A string indicating the type of operation to perform on the segment
            membership. Valid values include 'HAS_ALL_SEGMENT_MEMBERSHIP',
            'HAS_NO_SEGMENT_MEMBERSHIP', and
            'HAS_AT_LEAST_ONE_SEGMENT_MEMBERSHIP'.
          enum:
            - HAS_ALL_SEGMENT_MEMBERSHIP
            - HAS_AT_LEAST_ONE_SEGMENT_MEMBERSHIP
            - HAS_NO_SEGMENT_MEMBERSHIP
        segmentIds:
          type: array
          description: >-
            An array of integers representing the IDs of segments to be
            evaluated.
          items:
            type: integer
            format: int32
        value:
          type: number
          description: A number used as a value in the segment membership rule.
    PublicBoolPropertyOperation:
      title: BOOL
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - value
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set should be
            included in the operation.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'BOOL' for this
            component.
          default: BOOL
          enum:
            - BOOL
        operator:
          type: string
          description: A string representing the operator used in the boolean operation.
        value:
          type: boolean
          description: A boolean value that is used in the operation.
      x-hubspot-sub-type-impl: true
    PublicNumberPropertyOperation:
      title: NUMBER
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - value
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that do not have a
            value set for the property.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'NUMBER' by
            default.
          default: NUMBER
          enum:
            - NUMBER
        operator:
          type: string
          description: A string representing the operator used in the numerical operation.
        value:
          type: number
          description: A number representing the value used in the operation.
      x-hubspot-sub-type-impl: true
    PublicStringPropertyOperation:
      title: STRING
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - value
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that do not have a
            value set for the property.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'STRING' for
            this component.
          default: STRING
          enum:
            - STRING
        operator:
          type: string
          description: A string representing the operator used in the string operation.
        value:
          type: string
          description: A string representing the value to be used in the operation.
      x-hubspot-sub-type-impl: true
    PublicDateTimePropertyOperation:
      title: DATETIME
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - requiresTimeZoneConversion
        - timestamp
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects without a set value should be
            included in the operation.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is always
            'DATETIME' for this component.
          default: DATETIME
          enum:
            - DATETIME
        operator:
          type: string
          description: A string representing the operator used in the date-time operation.
        requiresTimeZoneConversion:
          type: boolean
          description: >-
            A boolean specifying if the operation requires conversion based on
            time zones.
        timestamp:
          type: integer
          description: >-
            An integer representing the timestamp for the operation, formatted
            as an int64.
          format: int64
      x-hubspot-sub-type-impl: true
    PublicRangedDatePropertyOperation:
      title: RANGED_DATE
      required:
        - includeObjectsWithNoValueSet
        - lowerBound
        - operationType
        - operator
        - requiresTimeZoneConversion
        - upperBound
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects without a set value should be
            included in the operation.
        lowerBound:
          type: integer
          description: >-
            An integer representing the lower bound of the date range, formatted
            as int64.
          format: int64
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'RANGED_DATE' by
            default.
          default: RANGED_DATE
          enum:
            - RANGED_DATE
        operator:
          type: string
          description: A string specifying the operator used in the operation.
        requiresTimeZoneConversion:
          type: boolean
          description: >-
            A boolean indicating whether the operation requires conversion based
            on time zones.
        upperBound:
          type: integer
          description: >-
            An integer representing the upper bound of the date range, formatted
            as int64.
          format: int64
      x-hubspot-sub-type-impl: true
    PublicComparativePropertyUpdatedOperation:
      title: COMPARATIVE_PROPERTY_UPDATED
      required:
        - comparisonPropertyName
        - includeObjectsWithNoValueSet
        - operationType
        - operator
      type: object
      properties:
        comparisonPropertyName:
          type: string
          description: A string specifying the name of the property to compare against.
        defaultComparisonValue:
          type: string
          description: >-
            A string representing the default value to use for comparison if the
            comparison property is not set.
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that do not have a
            value set for the property.
        operationType:
          type: string
          description: >-
            A string representing the type of operation. Defaults to
            'COMPARATIVE_PROPERTY_UPDATED'.
          default: COMPARATIVE_PROPERTY_UPDATED
          enum:
            - COMPARATIVE_PROPERTY_UPDATED
        operator:
          type: string
          description: A string indicating the operator used in the comparison.
      x-hubspot-sub-type-impl: true
    PublicComparativeDatePropertyOperation:
      title: COMPARATIVE_DATE
      required:
        - comparisonPropertyName
        - includeObjectsWithNoValueSet
        - operationType
        - operator
      type: object
      properties:
        comparisonPropertyName:
          type: string
          description: >-
            A string specifying the name of the property to be used for
            comparison.
        defaultComparisonValue:
          type: string
          description: >-
            A string representing the default value to use for comparison if the
            comparison property is not set.
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set for the
            comparison property should be included in the operation.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is
            'COMPARATIVE_DATE' for this component.
          default: COMPARATIVE_DATE
          enum:
            - COMPARATIVE_DATE
        operator:
          type: string
          description: A string representing the operator used for the comparison.
      x-hubspot-sub-type-impl: true
    PublicRollingDateRangePropertyOperation:
      title: ROLLING_DATE_RANGE
      required:
        - includeObjectsWithNoValueSet
        - numberOfDays
        - operationType
        - operator
        - requiresTimeZoneConversion
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that have no value
            set.
        numberOfDays:
          type: integer
          description: >-
            An integer representing the number of days in the rolling date
            range.
          format: int32
        operationType:
          type: string
          description: >-
            A string representing the type of operation. The default value is
            'ROLLING_DATE_RANGE'.
          default: ROLLING_DATE_RANGE
          enum:
            - ROLLING_DATE_RANGE
        operator:
          type: string
          description: A string specifying the operator used in the operation.
        requiresTimeZoneConversion:
          type: boolean
          description: >-
            A boolean indicating whether the operation requires time zone
            conversion.
      x-hubspot-sub-type-impl: true
    PublicRollingPropertyUpdatedOperation:
      title: ROLLING_PROPERTY_UPDATED
      required:
        - includeObjectsWithNoValueSet
        - numberOfDays
        - operationType
        - operator
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that have no value
            set for the property.
        numberOfDays:
          type: integer
          description: >-
            An integer specifying the number of days to consider for the rolling
            update operation.
          format: int32
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is
            'ROLLING_PROPERTY_UPDATED' by default.
          default: ROLLING_PROPERTY_UPDATED
          enum:
            - ROLLING_PROPERTY_UPDATED
        operator:
          type: string
          description: A string representing the operator used in the operation.
      x-hubspot-sub-type-impl: true
    PublicEnumerationPropertyOperation:
      title: ENUMERATION
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - values
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set for the
            property should be included in the operation.
        operationType:
          type: string
          description: >-
            A string representing the type of operation. The default and only
            valid value is 'ENUMERATION'.
          default: ENUMERATION
          enum:
            - ENUMERATION
        operator:
          type: string
          description: A string indicating the operator to be used in the operation.
        values:
          type: array
          description: >-
            An array of strings representing the specific enumeration values to
            be used in the operation.
          items:
            type: string
      x-hubspot-sub-type-impl: true
    PublicAllPropertyTypesOperation:
      title: ALL_PROPERTY
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set should be
            included in the operation.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'ALL_PROPERTY'
            by default.
          default: ALL_PROPERTY
          enum:
            - ALL_PROPERTY
        operator:
          type: string
          description: A string representing the operator used in the operation.
      x-hubspot-sub-type-impl: true
    PublicRangedNumberPropertyOperation:
      title: NUMBER_RANGED
      required:
        - includeObjectsWithNoValueSet
        - lowerBound
        - operationType
        - operator
        - upperBound
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set should be
            included in the operation.
        lowerBound:
          type: integer
          description: >-
            An integer representing the lower bound of the range, in int64
            format.
          format: int64
        operationType:
          type: string
          description: >-
            The type of operation being performed. This is a string with a
            default value of 'NUMBER_RANGED'.
          default: NUMBER_RANGED
          enum:
            - NUMBER_RANGED
        operator:
          type: string
          description: A string representing the operator used in the operation.
        upperBound:
          type: integer
          description: >-
            An integer representing the upper bound of the range, in int64
            format.
          format: int64
      x-hubspot-sub-type-impl: true
    PublicMultiStringPropertyOperation:
      title: MULTISTRING
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - values
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that do not have a
            value set for the property.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, with a default value of
            'MULTISTRING'.
          default: MULTISTRING
          enum:
            - MULTISTRING
        operator:
          type: string
          description: A string representing the operator used in the operation.
        values:
          type: array
          description: >-
            An array of strings representing the values involved in the
            operation.
          items:
            type: string
      x-hubspot-sub-type-impl: true
    PublicDatePropertyOperation:
      title: DATE
      required:
        - day
        - includeObjectsWithNoValueSet
        - month
        - operationType
        - operator
        - year
      type: object
      properties:
        day:
          type: integer
          description: An integer specifying the day component of the date operation.
          format: int32
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that have no value
            set for the date property.
        month:
          type: string
          description: A string specifying the month component of the date operation.
        operationType:
          type: string
          description: A string indicating the type of operation, which is always 'DATE'.
          default: DATE
          enum:
            - DATE
        operator:
          type: string
          description: A string representing the operator used in the date operation.
        year:
          type: integer
          description: An integer specifying the year component of the date operation.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicCalendarDatePropertyOperation:
      title: CALENDAR_DATE
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - timeUnit
      type: object
      properties:
        fiscalYearStart:
          type: string
          description: >-
            A string representing the starting month of the fiscal year. Valid
            values include months from 'JANUARY' to 'DECEMBER'.
          enum:
            - APRIL
            - AUGUST
            - DECEMBER
            - FEBRUARY
            - JANUARY
            - JULY
            - JUNE
            - MARCH
            - MAY
            - NOVEMBER
            - OCTOBER
            - SEPTEMBER
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that have no value
            set.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'CALENDAR_DATE'
            by default.
          default: CALENDAR_DATE
          enum:
            - CALENDAR_DATE
        operator:
          type: string
          description: A string representing the operator used in the operation.
        timeUnit:
          type: string
          description: A string specifying the unit of time used in the operation.
        timeUnitCount:
          type: integer
          description: An integer specifying the count of time units used in the operation.
          format: int32
        useFiscalYear:
          type: boolean
          description: >-
            A boolean indicating whether to use the fiscal year in the
            operation.
      x-hubspot-sub-type-impl: true
    PublicTimePointOperation:
      title: TIME_POINT
      required:
        - includeObjectsWithNoValueSet
        - operationType
        - operator
        - timePoint
        - type
      type: object
      properties:
        endpointBehavior:
          type: string
          description: >-
            A string describing the behavior at the endpoint of the time point
            operation.
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that have no value
            set for the property.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is 'TIME_POINT' by
            default.
          default: TIME_POINT
          enum:
            - TIME_POINT
        operator:
          type: string
          description: A string representing the operator used in the time point operation.
        propertyParser:
          type: string
          description: >-
            A string specifying the parser used for the property in the
            operation.
        timePoint:
          description: >-
            An object representing the specific time point for the operation. It
            can be a date point, indexed time point, or property-referenced
            time.
          oneOf:
            - $ref: '#/components/schemas/PublicDatePoint'
            - $ref: '#/components/schemas/PublicIndexedTimePoint'
            - $ref: '#/components/schemas/PublicPropertyReferencedTime'
        type:
          type: string
          description: >-
            A string representing the type of the operation, which is used to
            categorize the operation.
      x-hubspot-sub-type-impl: true
    PublicRangedTimeOperation:
      title: TIME_RANGED
      required:
        - includeObjectsWithNoValueSet
        - lowerBoundTimePoint
        - operationType
        - operator
        - type
        - upperBoundTimePoint
      type: object
      properties:
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set should be
            included.
        lowerBoundEndpointBehavior:
          type: string
          description: A string defining the behavior of the lower bound endpoint.
        lowerBoundTimePoint:
          description: >-
            Specifies the lower bound time point, which can be a date, indexed
            time point, or property-referenced time.
          oneOf:
            - $ref: '#/components/schemas/PublicDatePoint'
            - $ref: '#/components/schemas/PublicIndexedTimePoint'
            - $ref: '#/components/schemas/PublicPropertyReferencedTime'
        operationType:
          type: string
          description: A string representing the operation type.
        operator:
          type: string
          description: A string representing the operator used in the time operation.
        propertyParser:
          type: string
          description: A string specifying the property parser to be used.
        type:
          type: string
          description: >-
            A string indicating the type of operation, defaulting to
            'TIME_RANGED'.
          default: TIME_RANGED
          enum:
            - TIME_RANGED
        upperBoundEndpointBehavior:
          type: string
          description: A string defining the behavior of the upper bound endpoint.
        upperBoundTimePoint:
          description: >-
            Specifies the upper bound time point, which can be a date, indexed
            time point, or property-referenced time.
          oneOf:
            - $ref: '#/components/schemas/PublicDatePoint'
            - $ref: '#/components/schemas/PublicIndexedTimePoint'
            - $ref: '#/components/schemas/PublicPropertyReferencedTime'
      x-hubspot-sub-type-impl: true
    PublicComparativeStringPropertyOperation:
      title: COMPARATIVE_STRING
      required:
        - comparisonPropertyName
        - includeObjectsWithNoValueSet
        - operationType
        - operator
      type: object
      properties:
        comparisonPropertyName:
          type: string
          description: >-
            A string specifying the name of the property to be used for
            comparison.
        defaultComparisonValue:
          type: string
          description: >-
            A string that provides a default value for comparison if the
            property value is not set.
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether to include objects that have no value
            set for the property being compared.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is
            'COMPARATIVE_STRING' by default.
          default: COMPARATIVE_STRING
          enum:
            - COMPARATIVE_STRING
        operator:
          type: string
          description: A string representing the operator used in the comparison.
      x-hubspot-sub-type-impl: true
    PublicComparativeNumberPropertyOperation:
      title: COMPARATIVE_NUMBER
      required:
        - comparisonPropertyName
        - includeObjectsWithNoValueSet
        - operationType
        - operator
      type: object
      properties:
        comparisonPropertyName:
          type: string
          description: A string specifying the name of the property to compare against.
        defaultComparisonValue:
          type: string
          description: >-
            A string representing the default value to use for comparison if the
            comparison property is not set.
        includeObjectsWithNoValueSet:
          type: boolean
          description: >-
            A boolean indicating whether objects with no value set for the
            property should be included in the operation.
        operationType:
          type: string
          description: >-
            A string indicating the type of operation, which is always
            'COMPARATIVE_NUMBER' for this component.
          default: COMPARATIVE_NUMBER
          enum:
            - COMPARATIVE_NUMBER
        operator:
          type: string
          description: >-
            A string representing the operator used in the comparison, such as
            'equals', 'greater than', etc.
      x-hubspot-sub-type-impl: true
    PublicSingleCondition:
      title: SINGLE
      required:
        - operation
        - property
        - type
      type: object
      properties:
        operation:
          description: >-
            An operation defining how the property is evaluated. This can be one
            of several types of operations, such as boolean, number, string,
            date-time, and others.
          oneOf:
            - $ref: '#/components/schemas/PublicBoolPropertyOperation'
            - $ref: '#/components/schemas/PublicNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDateTimePropertyOperation'
            - $ref: '#/components/schemas/PublicRangedDatePropertyOperation'
            - $ref: '#/components/schemas/PublicComparativePropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicComparativeDatePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingDateRangePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingPropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicEnumerationPropertyOperation'
            - $ref: '#/components/schemas/PublicAllPropertyTypesOperation'
            - $ref: '#/components/schemas/PublicRangedNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicMultiStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDatePropertyOperation'
            - $ref: '#/components/schemas/PublicCalendarDatePropertyOperation'
            - $ref: '#/components/schemas/PublicTimePointOperation'
            - $ref: '#/components/schemas/PublicRangedTimeOperation'
            - $ref: '#/components/schemas/PublicComparativeStringPropertyOperation'
            - $ref: '#/components/schemas/PublicComparativeNumberPropertyOperation'
        property:
          type: string
          description: >-
            A string representing the name of the property that the condition is
            based on.
        type:
          type: string
          description: >-
            A string indicating the type of condition. The default value is
            'SINGLE'.
          default: SINGLE
          enum:
            - SINGLE
      x-hubspot-sub-type-impl: true
    PublicEventFrequencyBetween:
      title: BETWEEN
      required:
        - ranges
        - type
      type: object
      properties:
        ranges:
          type: array
          description: >-
            An array of frequency ranges, each specifying the conditions for
            event occurrence within a defined range.
          items:
            $ref: '#/components/schemas/PublicFrequencyRange'
        type:
          type: string
          description: >-
            A string indicating the type of frequency evaluation, which is
            'BETWEEN' for this component.
          default: BETWEEN
          enum:
            - BETWEEN
      x-hubspot-sub-type-impl: true
    PublicEventTimeframe:
      required:
        - eventFilterOperation
      type: object
      properties:
        eventFilterOperation:
          description: >-
            Defines the operation used to filter events. This can be one of
            several property operations, such as boolean, number, string,
            date-time, and others, allowing for a wide range of filtering
            criteria.
          oneOf:
            - $ref: '#/components/schemas/PublicBoolPropertyOperation'
            - $ref: '#/components/schemas/PublicNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDateTimePropertyOperation'
            - $ref: '#/components/schemas/PublicRangedDatePropertyOperation'
            - $ref: '#/components/schemas/PublicComparativePropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicComparativeDatePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingDateRangePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingPropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicEnumerationPropertyOperation'
            - $ref: '#/components/schemas/PublicAllPropertyTypesOperation'
            - $ref: '#/components/schemas/PublicRangedNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicMultiStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDatePropertyOperation'
            - $ref: '#/components/schemas/PublicCalendarDatePropertyOperation'
            - $ref: '#/components/schemas/PublicTimePointOperation'
            - $ref: '#/components/schemas/PublicRangedTimeOperation'
            - $ref: '#/components/schemas/PublicComparativeStringPropertyOperation'
            - $ref: '#/components/schemas/PublicComparativeNumberPropertyOperation'
    PublicPropertyFilter:
      title: PROPERTY
      required:
        - filterType
        - operation
        - property
      type: object
      properties:
        filterType:
          type: string
          description: >-
            A string that specifies the type of filter being applied. The
            default value is 'PROPERTY'.
          default: PROPERTY
          enum:
            - PROPERTY
        operation:
          description: >-
            An object that defines the operation to be performed on the
            specified property. This can be one of several types of operations,
            such as boolean, number, string, date, and others, as defined by the
            various operation schemas.
          oneOf:
            - $ref: '#/components/schemas/PublicBoolPropertyOperation'
            - $ref: '#/components/schemas/PublicNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDateTimePropertyOperation'
            - $ref: '#/components/schemas/PublicRangedDatePropertyOperation'
            - $ref: '#/components/schemas/PublicComparativePropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicComparativeDatePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingDateRangePropertyOperation'
            - $ref: '#/components/schemas/PublicRollingPropertyUpdatedOperation'
            - $ref: '#/components/schemas/PublicEnumerationPropertyOperation'
            - $ref: '#/components/schemas/PublicAllPropertyTypesOperation'
            - $ref: '#/components/schemas/PublicRangedNumberPropertyOperation'
            - $ref: '#/components/schemas/PublicMultiStringPropertyOperation'
            - $ref: '#/components/schemas/PublicDatePropertyOperation'
            - $ref: '#/components/schemas/PublicCalendarDatePropertyOperation'
            - $ref: '#/components/schemas/PublicTimePointOperation'
            - $ref: '#/components/schemas/PublicRangedTimeOperation'
            - $ref: '#/components/schemas/PublicComparativeStringPropertyOperation'
            - $ref: '#/components/schemas/PublicComparativeNumberPropertyOperation'
        property:
          type: string
          description: >-
            A string representing the name of the property on which the filter
            operation will be applied.
      x-hubspot-sub-type-impl: true
    PublicDatePoint:
      title: DATE
      required:
        - day
        - month
        - timeType
        - year
        - zoneId
      type: object
      properties:
        day:
          type: integer
          description: An integer representing the day component of the date.
          format: int32
        hour:
          type: integer
          description: An integer representing the hour component of the time.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the millisecond component of the time.
          format: int32
        minute:
          type: integer
          description: An integer representing the minute component of the time.
          format: int32
        month:
          type: integer
          description: An integer representing the month component of the date.
          format: int32
        second:
          type: integer
          description: An integer representing the second component of the time.
          format: int32
        timeType:
          type: string
          description: >-
            A string indicating the type of time representation, defaulting to
            'DATE'.
          default: DATE
          enum:
            - DATE
        timezoneSource:
          type: string
          description: A string representing the source of the timezone information.
        year:
          type: integer
          description: An integer representing the year component of the date.
          format: int32
        zoneId:
          type: string
          description: A string specifying the timezone ID.
      x-hubspot-sub-type-impl: true
    PublicIndexedTimePoint:
      title: INDEXED
      required:
        - indexReference
        - timeType
        - zoneId
      type: object
      properties:
        indexReference:
          description: >-
            An object that defines the reference point for the indexed time,
            which can be one of several predefined references such as 'NOW',
            'TODAY', or specific time periods like 'WEEK' or 'MONTH'.
          oneOf:
            - $ref: '#/components/schemas/PublicNowReference'
            - $ref: '#/components/schemas/PublicTodayReference'
            - $ref: '#/components/schemas/PublicWeekReference'
            - $ref: '#/components/schemas/PublicFiscalQuarterReference'
            - $ref: '#/components/schemas/PublicFiscalYearReference'
            - $ref: '#/components/schemas/PublicYearReference'
            - $ref: '#/components/schemas/PublicQuarterReference'
            - $ref: '#/components/schemas/PublicMonthReference'
        offset:
          $ref: '#/components/schemas/PublicIndexOffset'
        timeType:
          type: string
          description: A string indicating the type of time point, defaulting to 'INDEXED'.
          default: INDEXED
          enum:
            - INDEXED
        timezoneSource:
          type: string
          description: A string representing the source of the timezone information.
        zoneId:
          type: string
          description: A string specifying the ID of the timezone.
      x-hubspot-sub-type-impl: true
    PublicPropertyReferencedTime:
      title: PROPERTY_REFERENCED
      required:
        - property
        - referenceType
        - timeType
        - zoneId
      type: object
      properties:
        property:
          type: string
          description: >-
            A string indicating the property that the time reference is
            associated with.
        referenceType:
          type: string
          description: A string that defines the type of reference for the time.
        timeType:
          type: string
          description: >-
            A string indicating the type of time reference, with a default value
            of 'PROPERTY_REFERENCED'.
          default: PROPERTY_REFERENCED
          enum:
            - PROPERTY_REFERENCED
        timezoneSource:
          type: string
          description: A string specifying the source of the timezone information.
        zoneId:
          type: string
          description: A string representing the ID of the timezone.
      x-hubspot-sub-type-impl: true
    PublicFrequencyRange:
      required:
        - from
        - type
        - value
      type: object
      properties:
        from:
          type: integer
          description: An integer specifying the starting point of the frequency range.
          format: int32
        to:
          type: integer
          description: >-
            An integer specifying the ending point of the frequency range. This
            property is optional and may not be present in all cases.
          format: int32
        type:
          type: string
          description: >-
            A string indicating the type of frequency range. Valid values
            include 'EXACTLY', 'BETWEEN', and 'AT_LEAST'.
          enum:
            - AT_LEAST
            - BETWEEN
            - EXACTLY
        value:
          type: number
          description: >-
            A number representing the specific value associated with the
            frequency range.
    PublicNowReference:
      title: NOW
      required:
        - referenceType
      type: object
      properties:
        hour:
          type: integer
          description: An integer representing the current hour of the day.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the current millisecond of the second.
          format: int32
        minute:
          type: integer
          description: An integer representing the current minute of the hour.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'NOW' by
            default.
          default: NOW
          enum:
            - NOW
        second:
          type: integer
          description: An integer representing the current second of the minute.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicTodayReference:
      title: TODAY
      required:
        - referenceType
      type: object
      properties:
        hour:
          type: integer
          description: An integer representing the hour of the day.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the millisecond within the second.
          format: int32
        minute:
          type: integer
          description: An integer representing the minute within the hour.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'TODAY' by
            default.
          default: TODAY
          enum:
            - TODAY
        second:
          type: integer
          description: An integer representing the second within the minute.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicWeekReference:
      title: WEEK
      required:
        - dayOfWeek
        - referenceType
      type: object
      properties:
        dayOfWeek:
          type: string
          description: >-
            A string representing the day of the week. Valid values include
            'MONDAY', 'TUESDAY', 'WEDNESDAY', 'THURSDAY', 'FRIDAY', 'SATURDAY',
            and 'SUNDAY'.
          enum:
            - FRIDAY
            - MONDAY
            - SATURDAY
            - SUNDAY
            - THURSDAY
            - TUESDAY
            - WEDNESDAY
        hour:
          type: integer
          description: An integer representing the hour of the day, ranging from 0 to 23.
          format: int32
        millisecond:
          type: integer
          description: >-
            An integer representing the millisecond of the second, ranging from
            0 to 999.
          format: int32
        minute:
          type: integer
          description: >-
            An integer representing the minute of the hour, ranging from 0 to
            59.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'WEEK' for this
            component.
          default: WEEK
          enum:
            - WEEK
        second:
          type: integer
          description: >-
            An integer representing the second of the minute, ranging from 0 to
            59.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicFiscalQuarterReference:
      title: FISCAL_QUARTER
      required:
        - day
        - month
        - referenceType
      type: object
      properties:
        day:
          type: integer
          description: An integer representing the day within the month.
          format: int32
        hour:
          type: integer
          description: An integer representing the hour of the day.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the millisecond within the second.
          format: int32
        minute:
          type: integer
          description: An integer representing the minute within the hour.
          format: int32
        month:
          type: integer
          description: An integer representing the month within the fiscal quarter.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, defaulting to
            'FISCAL_QUARTER'.
          default: FISCAL_QUARTER
          enum:
            - FISCAL_QUARTER
        second:
          type: integer
          description: An integer representing the second within the minute.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicFiscalYearReference:
      title: FISCAL_YEAR
      required:
        - day
        - month
        - referenceType
      type: object
      properties:
        day:
          type: integer
          description: >-
            An integer representing the day component of the fiscal year
            reference.
          format: int32
        hour:
          type: integer
          description: >-
            An integer representing the hour component of the fiscal year
            reference.
          format: int32
        millisecond:
          type: integer
          description: >-
            An integer representing the millisecond component of the fiscal year
            reference.
          format: int32
        minute:
          type: integer
          description: >-
            An integer representing the minute component of the fiscal year
            reference.
          format: int32
        month:
          type: integer
          description: >-
            An integer representing the month component of the fiscal year
            reference.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'FISCAL_YEAR' by
            default.
          default: FISCAL_YEAR
          enum:
            - FISCAL_YEAR
        second:
          type: integer
          description: >-
            An integer representing the second component of the fiscal year
            reference.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicYearReference:
      title: YEAR
      required:
        - day
        - month
        - referenceType
      type: object
      properties:
        day:
          type: integer
          description: An integer representing the day of the month.
          format: int32
        hour:
          type: integer
          description: An integer representing the hour of the day.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the millisecond within the second.
          format: int32
        minute:
          type: integer
          description: An integer representing the minute within the hour.
          format: int32
        month:
          type: integer
          description: An integer representing the month of the year.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'YEAR' by
            default.
          default: YEAR
          enum:
            - YEAR
        second:
          type: integer
          description: An integer representing the second within the minute.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicQuarterReference:
      title: QUARTER
      required:
        - day
        - month
        - referenceType
      type: object
      properties:
        day:
          type: integer
          description: An integer representing the day within the month.
          format: int32
        hour:
          type: integer
          description: An integer representing the hour of the day.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the millisecond within the second.
          format: int32
        minute:
          type: integer
          description: An integer representing the minute within the hour.
          format: int32
        month:
          type: integer
          description: An integer representing the month within the quarter.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'QUARTER' by
            default.
          default: QUARTER
          enum:
            - QUARTER
        second:
          type: integer
          description: An integer representing the second within the minute.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicMonthReference:
      title: MONTH
      required:
        - day
        - referenceType
      type: object
      properties:
        day:
          type: integer
          description: An integer representing the day of the month.
          format: int32
        hour:
          type: integer
          description: An integer representing the hour of the day.
          format: int32
        millisecond:
          type: integer
          description: An integer representing the millisecond within the second.
          format: int32
        minute:
          type: integer
          description: An integer representing the minute within the hour.
          format: int32
        referenceType:
          type: string
          description: >-
            A string indicating the type of reference, which is 'MONTH' by
            default.
          default: MONTH
          enum:
            - MONTH
        second:
          type: integer
          description: An integer representing the second within the minute.
          format: int32
      x-hubspot-sub-type-impl: true
    PublicIndexOffset:
      type: object
      properties:
        days:
          type: integer
          description: An integer representing the number of days to offset.
          format: int32
        hours:
          type: integer
          description: An integer representing the number of hours to offset.
          format: int32
        milliseconds:
          type: integer
          description: An integer representing the number of milliseconds to offset.
          format: int32
        minutes:
          type: integer
          description: An integer representing the number of minutes to offset.
          format: int32
        months:
          type: integer
          description: An integer representing the number of months to offset.
          format: int32
        quarters:
          type: integer
          description: An integer representing the number of quarters to offset.
          format: int32
        seconds:
          type: integer
          description: An integer representing the number of seconds to offset.
          format: int32
        weeks:
          type: integer
          description: An integer representing the number of weeks to offset.
          format: int32
        years:
          type: integer
          description: An integer representing the number of years to offset.
          format: int32
  responses:
    Error:
      description: An error occurred.
      content:
        '*/*':
          schema:
            $ref: '#/components/schemas/Error'

````